//**************************************************************
// author	Tony Madden	(tm@mqware.com)
//**************************************************************
#ifndef WORKSET_DEFINED
#define WORKSET_DEFINED

#include	<string>
#include	<cmqc.h>
#include	<imqi.hpp> 
#include	<maxconn.h>

using namespace std;

class	MaxConnStateData{
private:
	MXC_STATEDATA	sd;

public:
	MaxConnStateData();

	void	getStateDataAsString(char*);

	long	getEventFlag();
	string	getEventQueue();
	long	getEventState();
	long	getExistingConnections();
	long	getFrequencyOfPCFChecks();
	string	getLogFileDirectory();
	string	getLogFileName();
	long	getMaxConnections();
	long	getMaxNumberOfInUseAttempts();
	string	getStateDataType();
	long	getTimesAtConnMaxSinceLastPCFCheck();
	long	getTraceLevel();
	long	getWarnThreshold();

	void	initialize();
	void	loadStateData(char*,long);
	void	reset();

	void	setEventFlag(long);
	void	setEventQueue(string);
	void	setEventState(long);
	void	setExistingConnections(long);
	void	setFrequencyOfPCFChecks(long);
	void	setLogFileDirectory(string);
	void	setLogFileName(string);
	void	setMaxConnections(long);
	void	setMaxNumberOfInUseAttempts(long);
	void	setStateDataType(string);
	void	setTimesAtConnMaxSinceLastPCFCheck(long);
	void	setTraceLevel(long);
	void	setWarnThreshold(long);
};
	

class MaxConnWorkSet{
private:
	bool				bClearAllMessages;
	long				lOpenType;
	char				bootstrapCorrelationId[MQ_CORREL_ID_LENGTH];
	char				volatileCorrelationId[MQ_CORREL_ID_LENGTH];
	string				sQName;
	string				sChannelName;
	ImqQueue*			pQueue;	

	void	initialize();
public:
	MaxConnWorkSet();

	const char*				getBootstrapCorrelationId();
	long					getOpenType();
	string					getQName();
	ImqQueue*				getQueue();
	string					getChannelName();
	const char*				getVolatileCorrelationId();

	void					reset();

	void					setBootstrapCorrelationId(char[],long);
	void					setOpenType(long);
	void					setQName(string);
	void					setChannelName(string);
	void					setVolatileCorrelationId(char[],long);
	
};


	
#endif

