//***********************************************************************************************************
//
// MQ numeric constant conversion class
//
//
// author	Tony Madden	(tm@mqware.com)
//***********************************************************************************************************
#ifndef X_MQ_DEFINED
#define X_MQ_DEFINED

#define X_MQ_VERSION		"1.0.0"

#include	<cmqc.h>
#include	<cmqcfc.h>
#include	<cmqbc.h>
#include	<cmqxc.h> 
#include	<imqi.hpp> 
#include	<cmqc.h>

#include	<string>

#include	<x_mqconstants.h>


#define		XMQ_BITWISE_DELIMITER					','


using namespace std;


class	X_Mq{

private:
	static bool	numberToString(char*	,long,long,string*);
	static bool	stringToNumber(char*	,long,long*,string);

	static string	convertBitwiseNumberToString(char*,long,long,long);
	static bool		convertBitwiseNumberToString(char*,long,long,long,string*);

public:
	static bool		convertToStringMQAT(MQLONG,string*);
	static string	convertToStringMQAT(MQLONG);
	static bool		convertToNumberMQAT(MQLONG*,string);
	static long		convertToNumberMQAT(string);
	
	static bool		convertToStringMQCHS(long	,string*);
	static string	convertToStringMQCHS(long	);
	static bool		convertToNumberMQCHS(long*,string);
	static long		convertToNumberMQCHS(string);

	static	bool	convertToStringMQRC(MQLONG ,string*);
	static	string	convertToStringMQRC(MQLONG );
	static bool		convertToNumberMQRC(MQLONG*,string);
	static long		convertToNumberMQRC(string);

	static	bool	convertToStringMQMT(MQLONG ,string*);
	static	string	convertToStringMQMT(MQLONG );
	static bool		convertToNumberMQMT(MQLONG*,string);
	static long		convertToNumberMQMT(string);

	static	bool	convertToStringMQFB(MQLONG ,string*);
	static	string	convertToStringMQFB(MQLONG );
	static bool		convertToNumberMQFB(MQLONG*,string);
	static long		convertToNumberMQFB(string);

	static	bool	convertToStringMQOO(MQLONG ,string*);
	static	string	convertToStringMQOO(MQLONG );
	static bool		convertToNumberMQOO(MQLONG*,string);
	static long		convertToNumberMQOO(string);

	static bool		convertToNumberMQPMO(MQLONG*,string);
	static long		convertToNumberMQPMO(string);

	static bool		convertToNumberMQGMO(MQLONG*,string);
	static long		convertToNumberMQGMO(string);

	static bool		convertToNumberMQENC(MQLONG*,string);
	static long		convertToNumberMQENC(string);
	static	bool	convertToStringMQENC(MQLONG ,string*);
	static	string	convertToStringMQENC(MQLONG );


	static	bool	convertToStringMQPER(MQLONG ,string*);
	static	string	convertToStringMQPER(MQLONG );
	static bool		convertToNumberMQPER(MQLONG*,string);
	static long		convertToNumberMQPER(string);

	static bool		convertToStringMQCFT(MQLONG,string*);
	static string	convertToStringMQCFT(MQLONG);
	static bool		convertToNumberMQCFT(MQLONG*,string);
	static long		convertToNumberMQCFT(string);

	static bool		convertToStringMQCMD(MQLONG,string*);
	static string	convertToStringMQCMD(MQLONG);
	static bool		convertToNumberMQCMD(MQLONG*,string);
	static long		convertToNumberMQCMD(string);

	static bool		convertToStringMQQT(MQLONG,string*);
	static string	convertToStringMQQT(MQLONG);
	static bool		convertToNumberMQQT(MQLONG*,string);
	static long		convertToNumberMQQT(string);

	static bool		convertToStringMQCACH(MQLONG,string*);
	static string	convertToStringMQCACH(MQLONG);
	static bool		convertToNumberMQCACH(MQLONG*,string);
	static long		convertToNumberMQCACH(string);
//
	static bool		convertToStringMQXPT(MQLONG,string*);
	static string	convertToStringMQXPT(MQLONG);
	static bool		convertToNumberMQXPT(MQLONG*,string);
	static long		convertToNumberMQXPT(string);

	static bool		convertToStringMQCACF(MQLONG,string*);
	static string	convertToStringMQCACF(MQLONG);
	static bool		convertToNumberMQCACF(MQLONG*,string);
	static long		convertToNumberMQCACF(string);

	static bool		convertToStringMQIACH(MQLONG,string*);
	static string	convertToStringMQIACH(MQLONG);
	static bool		convertToNumberMQIACH(MQLONG*,string);
	static long		convertToNumberMQIACH(string);

	static bool		convertToStringMQIACF(MQLONG,string*);
	static string	convertToStringMQIACF(MQLONG);
	static bool		convertToNumberMQIACF(MQLONG*,string);
	static long		convertToNumberMQIACF(string);

	static bool		convertToStringMQIA(MQLONG,string*);
	static string	convertToStringMQIA(MQLONG);
	static bool		convertToNumberMQIA(MQLONG*,string);
	static long		convertToNumberMQIA(string);

	static bool		convertToStringMQCA(MQLONG,string*);
	static string	convertToStringMQCA(MQLONG);
	static bool		convertToNumberMQCA(MQLONG*,string);
	static long		convertToNumberMQCA(string);

	static bool		convertToStringMQMF(MQLONG,string*);
	static string	convertToStringMQMF(MQLONG);
	static bool		convertToNumberMQMF(MQLONG*,string);
	static long		convertToNumberMQMF(string);
	
	static bool		convertToStringMQRQ(MQLONG,string*);
	static string	convertToStringMQRQ(MQLONG);
	static bool		convertToNumberMQRQ(MQLONG*,string);
	static long		convertToNumberMQRQ(string);

	static bool		convertToStringMQRO(MQLONG,string*);
	static string	convertToStringMQRO(MQLONG);
	static bool		convertToNumberMQRO(MQLONG*,string);
	static long		convertToNumberMQRO(string);

	static bool		convertToStringMQUS(MQLONG,string*);
	static string	convertToStringMQUS(MQLONG);
	static bool		convertToNumberMQUS(MQLONG*,string);
	static long		convertToNumberMQUS(string);

	static bool		convertToStringMQTT(MQLONG,string*);
	static string	convertToStringMQTT(MQLONG);
	static bool		convertToNumberMQTT(MQLONG*,string);
	static long		convertToNumberMQTT(string);

	static bool		convertToStringMQPL(MQLONG,string*);
	static string	convertToStringMQPL(MQLONG);
	static bool		convertToNumberMQPL(MQLONG*,string);
	static long		convertToNumberMQPL(string);

	static bool		convertToStringMQQDT(MQLONG,string*);
	static string	convertToStringMQQDT(MQLONG);
	static bool		convertToNumberMQQDT(MQLONG*,string);
	static long		convertToNumberMQQDT(string);

	static string	getVersion();

	static	bool	sleep(long ,ImqQueueManager*);



};



#endif

